'*****************************************************************************
'* CATALOGUE BIBLIOTHEQUE : GENERATION DU FICHIER D'AIDE
'*
'* DJ   20.04.2010
'*****************************************************************************
'
' Le programme effectue les taches suivantes :
'	. boite de dialogue d'accueil qui demande si l'on effectue une gnration
'	  ou si l'on abandonne
'	. lecture des paramtres
'		ceux-ci donnent les chemins d'accs des divers fichiers
'	. cration de la page d'accueil (date de mj ...)
'	. cration des pages par auteur
'	. cration de l'index avec niveau type puis auteurs
'	. compilation du fichier d'aide et affichage
'
'*****************************************************************************
' Organisation du programme
'
' Les fonctions du programme sont incluses dans une classe
' En dehors de cette classe, on trouve les fonctions de gestion des boutons et 
' d'affichage de la barre de progression, base sur l'utilisation d'un timer
' afin d'assurer l'affichage en cours de droulement du traitement.
' Le principe est que le traitement d'une ligne se relance lui-meme via un
' timer (gr par la page html). Ce dlai donne le temps de rafraichir l'affichage.
' Ceci uniquement si l'on fonctionne sous le navigateur.
' En excution directe des scripts, pas de barre de progression
'*****************************************************************************


Option Explicit 

'*****     SCRIPTS DE GESTION DE LA PAGE

' objet pour cration de la classe 
public objgen
' environnement d'excution
dim envir
public indic_envir



' Recherche de l'environnement d'excution : si pas navigateur, lancer directement le traitement
' ... lecture
envir=""
on error resume next
envir=document
on error goto 0
if envir="" then
	indic_envir="VBS"
else
	indic_envir="NAV"
end if
' ... lancer traitement
if indic_envir <> "NAV" then
	script_debut_gen()
end if



' Lancement de la gnration
function script_debut_gen()
	' crer l'objet
	set objgen=new classe_gen
	' affecter la routine de timer
	objgen.fonction_timer="trtlig_gen()"
	' lancer
	objgen.traitement_debut(indic_envir)
end function



' Interruption de la gnration
function script_arret_gen()
	objgen.traitement_arret()
end function



' Traitement d'une ligne
' (appele uniquement si l'on est en mode navigateur)
function trtlig_gen()

	dim x
	dim lon

	' rafficher tous les 10 enregistrements traits
	x=objgen.nblus mod 10
    if x=0 or (objgen.nblus=objgen.nbmax-1) then
        ' longueur faite
        lon=cint(200*objgen.nblus/objgen.nbmax)
        document.getElementById("proggenfait").width=lon
        document.getElementById("proggenfait").style.visibility="visible"
        ' ... et  faire
        if lon >= 200 then
              document.getElementById("proggenreste").style.visibility=""
        else
            document.getElementById("proggenreste").width=200-lon
			document.getElementById("proggenreste").style.visibility="visible"
        end if
    end if

	' compteur en bas d'cran
	window.status=cstr(objgen.nblus)+" = " + objgen.art_encours
	
	' relancer la ligne suivante
	objgen.traite_ligne()

end function





'*****     DEFINITION DE LA CLASSE

class classe_gen

'*** INITIALISATION DES VARIABLES

'* objets script
private wwsh
private fso
private envir

'* environnement de dossiers/fichiers
private racine
private racine_pgm
private racine_pages
private racine_hh

private nomf_ini
private fmod
private fpag

private nombase

'* base de donnes
private dbh
private rstype
private rsaute, rsaute2
private rslivr

'* variables du programme
private titre_msgbox
private repacc
private reppar
private date_extr
private xdate1, xdate2, xdate3
private nbliv

'* volumetrie et progression
public nblus
public nbmax
public art_encours:' livre en cours de traitement
public indicfin:' indicateur d'arret
public fonction_timer:' nom de la fonction du timer
private indicaut:' indicateur pour lecture des auteurs
private indicliv:' indicateur pour lecture des livres



'***   ARRET DU TRAITEMENT

sub traitement_arret()
	indicfin="1"
end sub



'***   TRAITEMENT DE LA GENERATION

sub traitement_debut(penvir)

	set wwsh=createobject("wscript.shell")
	set fso=createobject("scripting.filesystemobject")
	envir=penvir


	init_variables


	'*** ACCUEIL (GENERATION ou FIN)
	repacc=accueil()
	' abandonner
	if repacc=vbcancel then
		exit sub
	end if

	' lire parametres de l'application
	reppar=lecture_parametres
	if reppar=0 then
		exit sub
	end if


	'*** OUVRIR LA BASE ET LES TABLES
	ouvre_base
	volumetrie

	'*** GENERER LA PAGE PRINCIPALE
	generer_principale

	'*** GENERER LES PAGES
	generer_pages

end sub




'*****************************************************************************
'
'					R O U T I N E S
'
'*****************************************************************************



'*****************************************************************************
'     ACCUEIL : CHOIX DU TRAITEMENT A REALISER
'*****************************************************************************
function accueil() 

	dim x
	x=msgbox("Voulez-vous crer le catalogue", vbokcancel, titre_msgbox)
	accueil=x

end function





'*****************************************************************************
'     LECTURE_PARAMETRES : RECUPERATION PARAMETRES DE L'APPLICATION
'*****************************************************************************
function lecture_parametres() 

	dim x
	dim xxx
	dim fpar

	racine=""
	lecture_parametres=1

	'* Ouvrir le fichier de paramtres (selon evironnement)
	dim chem
	if envir="NAV" then 
		chem=fso.getparentfoldername(document.location.href)
		chem=replace(chem, "file:///", "")
		chem=chem+"\"
	else
		chem=""
	end if

	If not (fso.FileExists(chem+nomf_ini)) Then
		x=msgbox("Fichier parametres non trouv", vbokonly, titre_msgbox)
		lecture_parametres=0
		exit function
	end if

	Set fpar = fso.OpenTextFile(chem+nomf_ini,1, True,0)

	'* Lire les lignes et stocker 
	while not fpar.atendofstream
		xxx=fpar.readline 
		if left(xxx,7)="RACINE=" then racine=mid(xxx,8)
		if left(xxx,9)="HTMLHELP=" then racine_hh=mid(xxx,10)
	wend
	
	fpar.close

	'* Vrifier que tous les paramtres sont remplis
	if racine="" then
		x=msgbox("Erreur dans les parametres", vbokonly, titre_msgbox)
		lecture_parametres=0
	end if

	racine_pgm=racine+"\pgm"
	racine_pages=racine+"\pages"

end function





'*****************************************************************************
'     INIT_VARIABLES : INITIALISATION
'*****************************************************************************
function init_variables() 

	nomf_ini="catalo.ini"
	nombase="biblio.mdb"
	titre_msgbox="Cration du catalogue"

end function





'*****************************************************************************
'     OUVRE_BASE : CONNECTE LA BASE ET OUVRE LES TABLES
'*****************************************************************************
function ouvre_base()

	dim connstring
	
	set dbh=createobject("adodb.connection")
	connstring="DRIVER={Microsoft Access Driver (*.mdb)}; " & "DBQ="+racine_pgm+"\"+nombase
	dbh.Open connstring 

	set rstype=createobject("adodb.recordset")
	set rsaute=createobject("adodb.recordset")
	set rslivr=createobject("adodb.recordset")

end function

'*****************************************************************************
'     FERME_BASE : DECONNECTE LA BASE ET FERME LES TABLES
'*****************************************************************************
function ferme_base()

	dbh.close

end function





'*****************************************************************************
'     GENERER_PRINCIPALE : GENERE LA PAGE D'ACCUEIL DU FICHIER
'*****************************************************************************
function generer_principale()

	' Effacer les fichiers pralablement gnrs
	on error resume next
	fso.deletefile racine_pages+"\_*.html", true
	on error goto 0
	
	' Lire la date/heure du jour et la formater
	xdate2=fmt_datejour()
	xdate3=fmt_heurejour()
			
	' ouvrir la page  crer
	Set fpag = fso.OpenTextFile(racine_pages+"\_principale.html",2,True,0)
	ecrpage "principale_modele.html"
	fpag.close

end function





'*****************************************************************************
'     GENERER_PAGES : CREE LES PAGES PAR TYPE
'
' Lire les auteurs par type
' Pour chaque auteur/type, lire les livres
' La mise en page s'effectue via un modle, dans lequel on remplace des 
' variables identifies par $xxx par leur valeur relle
' Il y a un modle pour l'entete, le corps et le bas de page
'
'*****************************************************************************
function generer_pages()

	indicaut=0
    indicfin="0"

	traite_ligne

end function



function traite_ligne()

' La procdure est organise de manire  lire les auteurs/type, puis les livre pour
' chacun. Chaque passage traite un seul livre; entre-temps, la barre de progression
' est actualise.
'
' Pour ce faire, des indicateurs prennent les valeurs suivantes
'	.0 = initialiser la requete et se positionner au dbut
'	.1 = lire l'enregistrement suivant
'	.2 = ne pas lire le suivant (par ex: le temps de traiter tous les articles)
'	.9 = fin de fichier
'
	dim query
	dim tim
	dim finboucle

	'* Boucler sur le traitement si l'on est en excution directe, hors navigateur
	finboucle="0"

	while finboucle="0"


	'* Touche d'arret ?
	if indicfin="1" then
		indicaut=9
		indicliv=9
	end if

	'* Lire les auteurs par type; initialiser la requete si ncessaire
	if indicaut < 2 then
		if indicaut=0 then
			query="select * from auteurs_par_type order by tylib, aumotd"
			rsaute.open(query), dbh, 3, 3
			nblus=0
		    'rsaute.movefirst
		else
			rsaute.movenext
		end if

		if rsaute.eof then
			' fin de fichier, pas d'articles
			indicaut=9
			indicliv=2
		else
			genere_auteur
			' ne pas lire l'auteur suivante et initialiser la req. livres
			indicaut=2
			indicliv=0
		end if
	end if
	
	'* Lire le livre; initialiser la requete si ncessaire
	if indicliv < 2 then
		if indicliv=0 then
			query="select * from livres where liaut="+cstr(rsaute.fields("aunume"))
			query=query+" and lityp="+cstr(rsaute.fields("tynume"))
			query=query+" order by linume desc"
			rslivr.open(query), dbh, 3, 3
			'rslivr.movefirst
		else
			rslivr.movenext
		end if

		if rslivr.eof then
			' fermer requete article et lire catgorie suivante
			indicaut=1
			indicliv=9
		else
			nblus=nblus+1
			ecrpage "auteur_detail_modele.html"
			indicliv=1:' article suivant
		end if
	end if
	
	'* Plus de livres pour l'auteur
	if indicliv = 9 then
		rslivr.close
		' ...   crer le bas de la page
		ecrpage "auteur_bas_modele.html"
		' ...   fermer le fichier de sortie
		fpag.close
	end if

	'* Type/auteur suivant ou fin de programme
	if indicaut <> 9 then
		if envir="NAV" then
			finboucle="1"
			tim=window.setTimeout(fonction_timer, 1)
		end if
	else
		rsaute.close
		' ... GENERER L'INDEX
		generer_index
		' ... COMPILER LE FICHIER
		compiler_fichier
		' ... FERMER LA BASE ET LES TABLES

		ferme_base

		msgbox "Cration du fichier termine", vbokonly, titre_msgbox
		finboucle="1"
	end if

	wend


end function



'*****************************************************************************
'     GENERE_AUTEUR : GENERE LA PAGE POUR UN AUTEUR
'*****************************************************************************
function genere_auteur()

	dim query
	
	'***   crer le fichier de sortie
	Set fpag = fso.OpenTextFile(racine_pages+"\_"+left(rsaute.fields("tylib"),3)+"_"+rsaute.fields("aumotd")+".html",2,True,0)

	'***   crer l'entete de la page
	' ... nbe de livres pour l'auteur
    nbliv=rsaute.fields("nblivr")
        
    ' ... crer la page
    ecrpage "auteur_entete_modele.html"

end function





'*****************************************************************************
'     ECRPAGE : CREE LE CODE EN REMPLACANT LES VARIABLES $ PAR LEUR VALEUR
'*****************************************************************************
function ecrpage(pnommodele)

	dim xxx
			
	' ouvrir le modle demand

	Set fmod = fso.OpenTextFile(racine_pgm+"\"+pnommodele,1,True,0)
	while not fmod.atendofstream
		xxx=fmod.readline 

		' remplacer les variables par les valeurs relles
		xxx=fonction_replace(xxx, "$DATCRE", xdate2)
		xxx=fonction_replace(xxx, "$HEUCRE", xdate3)
		xxx=fonction_replace(xxx, "$NOMBRETOTAL", cstr(nbmax))
		xxx=fonction_replace(xxx, "$NOMBRE/AUTEUR", cstr(nbliv))
		
		on error resume next: ' si fichiers pas ouverts
		xxx=fonction_replace(xxx, "$LINUME", rslivr.fields("linume"))
		xxx=fonction_replace(xxx, "$LITITR", rslivr.fields("lititr"))
		xxx=fonction_replace(xxx, "$AUMOTD", rsaute.fields("aumotd"))
		xxx=fonction_replace(xxx, "$AUNOM", rsaute.fields("aunom"))
		xxx=fonction_replace(xxx, "$TYLIB", rsaute.fields("tylib"))
		xxx=fonction_replace(xxx, "$TYPE", rstype.fields("tylib"))
		xxx=fonction_replace(xxx, "$TYP3", left(rstype.fields("tylib"),3))
		xxx=fonction_replace(xxx, "$AUTEUR", rsaute2.fields("AUMOTD"))
		
		on error goto 0

		fpag.writeline xxx
	wend
	fmod.close

end function






'*****************************************************************************
'     GENERER_INDEX : CREE L'INDEX DU PROJET D'AIDE
'
' Lire les types
' Gnrer une entete pour ce type
' Lire ensuite les auteurs pour ce type
' Gnrer une entete, dcale par rapport  la prcdente
'
'*****************************************************************************
function generer_index()

	dim query

	'***   Crer l'entete de l'index
	
	' ouvrir le fichier
	Set fpag = fso.OpenTextFile(racine_pages+"\catalogue.hhc",2,True,0)
	
	' crer le code
	ecrpage "index_entete.html"

	'***   Traiter les types
	query="select * from types order by tylib"
	rstype.open query, dbh, 3, 3

	rstype.movefirst
	while not rstype.eof
		genere_groupe
		rstype.movenext
	wend

	'***   Fermer l'index
	ecrpage "index_bas.html"
	
	fpag.close
	rstype.close

end function


function genere_groupe()

	dim query

	'***   Crer l'entete de type
	
	' crer le code
	ecrpage "index_aut_entete.html"

	'***   Traiter les auteurs rattachs
	query="select * from auteurs_par_type where tynume="+cstr(rstype.fields("tynume"))
	query=query+" order by aumotd"
	'msgbox query

	set rsaute2=createobject("adodb.recordset")
	rsaute2.open query, dbh, 3, 3 

	'rsaute2.movefirst
	while not rsaute2.eof
		ecrpage "index_detail.html"
		rsaute2.movenext
	wend

	'***   Fermer le type
	ecrpage "index_aut_bas.html"
	rsaute2.close
	set rsaute2=nothing

end function





'*****************************************************************************
'     GESTION DE LA PROGRESSION DU TRAITEMENT
'*****************************************************************************

'***   CALCUL DES VOLUMES POUR PARAMETRES DE PROGRESSION
function volumetrie

       	dim query

	' lire le nombre d'articles
	query="select count(*) from livres"
	rslivr.open(query), dbh, 3, 3
	rslivr.movefirst
	if rslivr.eof then
	       nbmax=1
	else
           nbmax=rslivr.fields(0)
	end if
	rslivr.close

end function





'*****************************************************************************
'     COMPILER_FICHIER : COMPILE LE PROJET ET L'AFFICHE
'*****************************************************************************
function compiler_fichier()

	dim x
	dim xxx
	dim cmd
	
	' Compiler avec log de compil dans un fichier texte
	'  (il faut crer un bat car la redirection n'est pas comprise par run)
	cmd=racine_hh+" "+racine_pages+"\catalogue.hhp >" +racine_pages+"\catalogue.txt"
	Set fpag = fso.OpenTextFile(racine_pages+"\catalogue.bat",2, True,0)
	fpag.writeline cmd
	fpag.close

	x=wwsh.run(racine_pages+"\catalogue.bat" , 4, true)
	
	' Vrifier le log de compil
	Set fpag = fso.OpenTextFile(racine_pages+"\catalogue.txt",1,True,0)
	do while not fpag.atendofstream
		xxx=fpag.readline
		if instr(1, xxx, "Error") <> 0 then
			x=msgbox("Erreur de cration du fichier"+vbcrlf+vbcrlf+"Voir le fichier "+racine_pages+"\catalogue.txt", vbok, titre_msgbox)
			exit do
		end if
	loop
	fpag.close

	' Afficher le fichier
	x=wwsh.run(racine_pages+"\catalogue.chm", 3, true)

end function





'*****************************************************************************
'     FMT_AAMMJJ : FORMAT DE DATE AAAAMMJJ -> jj/mm/AAAA
'*****************************************************************************
function fmt_aammjj(pdate)

	dim xxx
	
	xxx=cstr(pdate)
	fmt_aammjj=mid(xxx, 7, 2) + "." + mid(xxx, 5, 2) + "." + mid(xxx, 1, 4)
	
end function


'*****************************************************************************
'     FMT_DATEJOUR : FORMAT DE DATE DU JOUR EN jj/mm/AAAA
'*****************************************************************************
function fmt_datejour()

	dim xxx
	dim xx2

	xxx=date()
	xx2=10000*year(xxx)+100*month(xxx)+day(xxx)
	fmt_datejour=fmt_aammjj(xx2)
	
end function


'*****************************************************************************
'     FMT_HEUREJOUR : FORMAT D'HEURE -> HH:MM
'*****************************************************************************
function fmt_heurejour()

	dim xxx

	xxx=time()
	fmt_heurejour=FormatDateTime(xxx, vbshorttime)
	
end function


'*****************************************************************************
'     FMT_MONTANT : FORMATAGE D'UN MONTANT 
'*****************************************************************************
function fmt_montant(pmont)

	fmt_montant=Formatnumber(pmont, 4)
	
end function


'*****************************************************************************
'     FONCTION_REPLACE : REMPLACE UNE SOUS CHAINE DE CARACTERE, BLANC SI VIDE
'*****************************************************************************
function fonction_replace(pstr1, pstr2, pstr3)
' params :
'	. pstr1=chaine dans laquelle rechercher la sous-chaine
'	. pstr2=sous-chaine cherche
'	. pstr3=chaine de remplacement

	if pstr3="" or isempty(pstr3) then
		pstr3="&nbsp;"
	end if
	fonction_replace=replace(pstr1, pstr2, pstr3)
	
end function

end class
